# React Developer Coding Challenge

In this test you will be asked to perform a few tasks in a simple React app to showcase what you can do.
We want to test your knowledge of consuming APIs and handling response as well as your creativity, so both code quality and UI will be evaluated.

## Setting up the project

All you need to get going is to run `npm install` in your terminal.
Once the dependencies are installed, run `npm start` and the project will be fired up in your browser.

Node-fetch is installed as a dependency and behaves exactly like the browser native fetch API, but feel free to use axios or any other library for http calls if you have other preferences.

## The Task

Build a simple React app that allows viewing and interacting with a grid of movies from data fetched from the Star Wars API (https://swapi.co/)

Complete the following tasks to achieve MVP:

1. Use a Navbar component to allow the user to switch between **Movies** and **Characters** pages.
2. On movies page: display a grid of movies with live data fetched from the Star Wars API (https://swapi.dev/api/).
3. Use a Loader component when loading movie data.
4. When a user clicks on a movie item, switch to a **SingleMovie** page, and make it display data for the clicked movie.
5. The Characters page should be empty to start with, and only get characters added as the user clicks into the different movies. This page should only display characters belonging to movies that the user has clicked on. How you populate the Characters page is up to you.
6. The app should be built and styled with a mobile first approach.
7. Make use of component states and hooks across the app to ensure you are fetching data as little as possible, only when needed and at the right time.

## Bonus

1. Implement a **SingleCharacter** component that will be visited each time a user clicks on a single character.
2. When a user visits this component, fetch and display data regarding the character's race, planet and starships.
3. Use TypeScript
4. Use Styled Components

## Tips

- You're free to use existing open source React components or JavaScript/CSS packages/libraries from npm to complete this task.
- Simplicity, readability and reusability are at the core of good code. Keep your solutions as straight forward, readable and reusable as possible.
- We won't judge you based on how you did something, but based on **WHY** you chose to do it that way.
- Don't rush. We rather see 2 well implemented features than 4 bad ones.
- Even if you feel like you get stuck or your results are bad, submit the code and let's discuss it. We'd love to learn about your thought process about where the shortcommings happened and why.

Keep an eye on network calls. We want to do as few of these as possible.
If you have any questions regarding the task, contact andreas.casen@stampen.com.
